Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/fisrtilp.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/fisrtilp.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/fisrtilp.F90	(revision 3605)
@@ -740,11 +740,20 @@
                call cloudth(klon,klev,k,ztv, &
                    zq,zqta,fraca, &
-                   qcloud,ctot,zpspsk,paprs,ztla,zthl, &
+                   qcloud,ctot,zpspsk,paprs,pplay,ztla,zthl, &
                    ratqs,zqs,t)
-              elseif (iflag_cloudth_vert>=3) then
+              elseif (iflag_cloudth_vert>=3 .and. iflag_cloudth_vert<=5) then
                call cloudth_v3(klon,klev,k,ztv, &
                    zq,zqta,fraca, &
-                   qcloud,ctot,ctot_vol,zpspsk,paprs,ztla,zthl, &
+                   qcloud,ctot,ctot_vol,zpspsk,paprs,pplay,ztla,zthl, &
                    ratqs,zqs,t)
+              !----------------------------------
+              !Version these Jean Jouhaud, Decembre 2018 
+              !----------------------------------              
+              elseif (iflag_cloudth_vert==6) then
+               call cloudth_v6(klon,klev,k,ztv, &
+                   zq,zqta,fraca, &
+                   qcloud,ctot,ctot_vol,zpspsk,paprs,pplay,ztla,zthl, &
+                   ratqs,zqs,t)
+
               endif
               do i=1,klon
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/flott_gwd_rando_m.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/flott_gwd_rando_m.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/flott_gwd_rando_m.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 module FLOTT_GWD_rando_m
 
@@ -20,4 +23,6 @@
       USE ioipsl_getin_p_mod, ONLY : getin_p
       USE vertical_layers_mod, ONLY : presnivs
+      CHARACTER (LEN=20) :: modname='flott_gwd_rando'
+      CHARACTER (LEN=80) :: abort_message
 
       include "YOMCST.h"
@@ -115,8 +120,4 @@
     LOGICAL, SAVE :: firstcall = .TRUE.
   !$OMP THREADPRIVATE(firstcall,gwd_reproductibilite_mpiomp)
-
-    CHARACTER (LEN=20) :: modname='flott_gwd_rando'
-    CHARACTER (LEN=80) :: abort_message
-
 
 
@@ -198,11 +199,11 @@
 
     IF(DELTAT < DTIME)THEN
-       PRINT *, 'flott_gwd_rando: deltat < dtime!'
-       STOP 1
+       abort_message='flott_gwd_rando: deltat < dtime!'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
     IF (KLEV < NW) THEN
-       PRINT *, 'flott_gwd_rando: you will have problem with random numbers'
-       STOP 1
+       abort_message='flott_gwd_rando: you will have problem with random numbers'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/geo2atm.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/geo2atm.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/geo2atm.F90	(revision 3605)
@@ -5,11 +5,21 @@
   USE dimphy
   USE mod_phys_lmdz_para
-
+  USE mod_grid_phy_lmdz, only: grid_type, unstructured, regular_lonlat
   IMPLICIT NONE
   INCLUDE 'YOMCST.h'
+  CHARACTER (len = 6)                :: clmodnam
+  CHARACTER (len = 20)               :: modname = 'geo2atm'
+  CHARACTER (len = 80)               :: abort_message
 
 ! Change wind coordinates from cartesian geocentric to local spherical
 ! NB! Fonctionne probablement uniquement en MPI seul (sans OpenMP)
 !
+! Geocentric :
+  ! axe x is eastward : crosses (0N,90E) point.
+  ! axe y  crosses (0N,180E) point.
+  ! axe z is 'up' : crosses north pole.
+!
+! NB! Aux poles, fonctionne probablement uniquement en MPI seul (sans OpenMP)
+
   INTEGER, INTENT (IN)                 :: im, jm
   REAL, DIMENSION (im,jm), INTENT(IN)  :: px, py, pz
@@ -17,9 +27,10 @@
   REAL, DIMENSION (im,jm), INTENT(OUT) :: pu, pv, pr
 
-  REAL :: rad
+  REAL :: rad,reps
 
 
   rad = rpi / 180.0E0
-  
+  reps = 1.0e-5
+
   pu(:,:) = &
        - px(:,:) * SIN(rad * plon(:,:)) &
@@ -36,17 +47,34 @@
        + pz(:,:) * SIN(rad * plat(:,:))
 
-  ! Value at North Pole
-  IF (is_north_pole_dyn) THEN
-     pu(:, 1) = -px (1,1)
-     pv(:, 1) = -py (1,1)
-     pr(:, 1) = 0.0
-  ENDIF
+  IF (grid_type==regular_lonlat) THEN
+    ! Value at North Pole
+    IF (is_north_pole_dyn) THEN
+       pu(:, 1) = -px (1,1)
+       pv(:, 1) = -py (1,1)
+       pr(:, 1) = 0.0
+    ENDIF
   
-  ! Value at South Pole     
-  IF (is_south_pole_dyn) THEN
-     pu(:,jm) = -px (1,jm)
-     pv(:,jm) = -py (1,jm)
-     pr(:,jm) = 0.0
-  ENDIF
+    ! Value at South Pole     
+    IF (is_south_pole_dyn) THEN
+       pu(:,jm) = -px (1,jm)
+       pv(:,jm) = -py (1,jm)
+       pr(:,jm) = 0.0
+    ENDIF
+
+  ELSE IF (grid_type==unstructured) THEN
+     ! Pole nord pour Dynamico
+     WHERE ( plat(:,:) >= 90.0-reps )
+        pu(:,:) =  py(:,:)
+        pv(:,:) = -px(:,:)
+        pr(:,:) = 0.0e0
+     END WHERE
+
+  ELSE
+     abort_message='Problem: unknown grid type'
+     CALL abort_physic(modname,abort_message,1)
+  END IF
+
+  
+  
   
 END SUBROUTINE geo2atm
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/grid_noro_m.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/grid_noro_m.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/grid_noro_m.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 MODULE grid_noro_m
 !
@@ -334,6 +337,4 @@
   imar=assert_eq(SIZE(x),SIZE(zphi,1),SIZE(mask,1),TRIM(modname)//" imar")-1
   jmar=assert_eq(SIZE(y),SIZE(zphi,2),SIZE(mask,2),TRIM(modname)//" jmar")
-! IF(imar/=iim)   CALL abort_gcm(TRIM(modname),'imar/=iim'  ,1)
-! IF(jmar/=jjm+1) CALL abort_gcm(TRIM(modname),'jmar/=jjm+1',1)
   iext=imdp/10
   xpi = ACOS(-1.)
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/ini_undefSTD.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/ini_undefSTD.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/ini_undefSTD.F90	(revision 3605)
@@ -55,5 +55,5 @@
 
     IF (n==1 .AND. itap-itapm1==1 .OR. n>1 .AND. mod(itap,nint( &
-        freq_outnmc(n)/dtime))==1) THEN
+        freq_outnmc(n)/phys_tstep))==1) THEN
       ! print*,'ini_undefSTD n itap',n,itap
       DO k = 1, nlevstd
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/inifis_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/inifis_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/inifis_mod.F90	(revision 3605)
@@ -6,5 +6,6 @@
   SUBROUTINE inifis(punjours, prad, pg, pr, pcpp)
   ! Initialize some physical constants and settings
-  USE print_control_mod, ONLY: init_print_control, lunout
+  USE init_print_control_mod, ONLY : init_print_control
+  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/iophy.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/iophy.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/iophy.F90	(revision 3605)
@@ -18,10 +18,5 @@
 #ifdef CPP_XIOS
   INTERFACE histwrite_phy
-!#ifdef CPP_XIOSnew
     MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy,histwrite2d_phy_old,histwrite3d_phy_old,histwrite2d_xios,histwrite3d_xios,histwrite0d_xios
-!#else
-!    MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy,histwrite2d_phy_old,histwrite3d_phy_old,histwrite2d_xios,histwrite3d_xios
-!#endif
-
   END INTERFACE
 #else
@@ -52,11 +47,11 @@
                                   mpi_size, mpi_rank, klon_mpi, &
                                 is_sequential, is_south_pole_dyn
-    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo
-    USE print_control_mod, ONLY: prt_level,lunout 
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, grid_type, unstructured
+  USE print_control_mod, ONLY: prt_level,lunout 
 #ifdef CPP_IOIPSL
     USE ioipsl, ONLY: flio_dom_set
 #endif
 #ifdef CPP_XIOS
-    USE wxios, ONLY: wxios_domain_param
+  use wxios, ONLY: wxios_domain_param, wxios_domain_param_unstructured, wxios_context_init
 #endif
     IMPLICIT NONE
@@ -77,8 +72,21 @@
     INTEGER :: data_ibegin, data_iend
 
-    CALL gather(rlat,rlat_glo)
-    CALL bcast(rlat_glo)
-    CALL gather(rlon,rlon_glo)
-    CALL bcast(rlon_glo)
+#ifdef CPP_XIOS
+      CALL wxios_context_init
+#endif
+    
+
+    IF (grid_type==unstructured) THEN
+    
+#ifdef CPP_XIOS
+      CALL wxios_domain_param_unstructured("dom_glo")
+#endif
+
+    ELSE
+
+      CALL gather(rlat,rlat_glo)
+      CALL bcast(rlat_glo)
+      CALL gather(rlon,rlon_glo)
+      CALL bcast(rlon_glo)
     
 !$OMP MASTER  
@@ -133,32 +141,34 @@
 #endif
 #ifdef CPP_XIOS
-    ! Set values for the mask:
-    IF (mpi_rank == 0) THEN
-        data_ibegin = 0
-    ELSE 
-        data_ibegin = ii_begin - 1
-    ENDIF
-
-    IF (mpi_rank == mpi_size-1) THEN
-        data_iend = nbp_lon
-    ELSE
-        data_iend = ii_end + 1
-    ENDIF
-
-    IF (prt_level>=10) THEN
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," iibegin=",ii_begin , " ii_end=",ii_end," jjbegin=",jj_begin," jj_nb=",jj_nb," jj_end=",jj_end
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," nbp_lon=",nbp_lon," nbp_lat=",nbp_lat
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole=",is_south_pole_dyn
-    ENDIF
-
-    ! Initialize the XIOS domain coreesponding to this process:
-    CALL wxios_domain_param("dom_glo", is_sequential, nbp_lon, jj_nb, nbp_lon, nbp_lat, &
-                            1, nbp_lon, ii_begin, ii_end, jj_begin, jj_end,             &
-                            klon_mpi+2*(nbp_lon-1), data_ibegin, data_iend,             &
-                            io_lat, io_lon,is_south_pole_dyn,mpi_rank)
+      ! Set values for the mask:
+      IF (mpi_rank == 0) THEN
+          data_ibegin = 0
+      ELSE 
+          data_ibegin = ii_begin - 1
+      END IF
+
+      IF (mpi_rank == mpi_size-1) THEN
+          data_iend = nbp_lon
+      ELSE
+          data_iend = ii_end + 1
+      END IF
+
+      IF (prt_level>=10) THEN
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," iibegin=",ii_begin , " ii_end=",ii_end," jjbegin=",jj_begin," jj_nb=",jj_nb," jj_end=",jj_end
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," nbp_lon=",nbp_lon," nbp_lat=",nbp_lat
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole_dyn=",is_south_pole_dyn
+      ENDIF
+
+      ! Initialize the XIOS domain coreesponding to this process:
 #endif
 !$OMP END MASTER
+
+#ifdef CPP_XIOS    
+        CALL wxios_domain_param("dom_glo")
+#endif
+      
+    ENDIF
       
   END SUBROUTINE init_iophy_new
@@ -291,5 +301,5 @@
                                 is_sequential, klon_mpi_begin, klon_mpi_end, &
                                 mpi_rank
-  USE mod_grid_phy_lmdz, ONLY: klon_glo, nbp_lon, nbp_lat
+  USE mod_grid_phy_lmdz, ONLY: klon_glo, nbp_lon, nbp_lat, grid1dTo2d_glo
   USE ioipsl, ONLY: histbeg
 
@@ -366,5 +376,5 @@
      ENDDO
 
-       CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlon_glo,zx_lon)
+       CALL grid1dTo2d_glo(rlon_glo,zx_lon)
        IF ((nbp_lon*nbp_lat).GT.1) THEN
        DO i = 1, nbp_lon
@@ -373,5 +383,5 @@
        ENDDO
        ENDIF
-       CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlat_glo,zx_lat)
+       CALL grid1dTo2d_glo(rlat_glo,zx_lat)
 
     DO i=1,pim
@@ -963,8 +973,9 @@
                                  nid_files, swaerofree_diag, swaero_diag, dryaod_diag, ok_4xCO2atm
   USE print_control_mod, ONLY: prt_level,lunout
-  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat, grid_type, unstructured, regular_lonlat
 #ifdef CPP_XIOS
   USE xios, ONLY: xios_send_field
 #endif
+  USE print_control_mod, ONLY: lunout, prt_level
 
   IMPLICIT NONE
@@ -1007,5 +1018,6 @@
       IF (.not. ok_all_xml) THEN
       IF (prt_level >= 10) THEN
-      WRITE (lunout,*)"histwrite2d_phy: .not.vars_defined ; time to define ", trim(var%name)
+      write(lunout,*)"histwrite2d_phy: .not.vars_defined ; time to define ", &
+                     trim(var%name)
       ENDIF
       DO iff=iff_beg, iff_end
@@ -1025,5 +1037,5 @@
 
     !Et sinon on.... écrit
-    IF (SIZE(field)/=klon .AND. SIZE(field)/=klev) CALL abort_physic('iophy::histwrite2d_phy','Field first DIMENSION not equal to klon/klev',1)    
+    IF (SIZE(field)/=klon .AND. SIZE(field)/=klev .AND. SIZE(field)/=klev+1) CALL abort_physic('iophy::histwrite2d_phy','Field first DIMENSION not equal to klon/klev',1)    
     IF (prt_level >= 10) THEn
       WRITE (lunout,*)"histwrite2d_phy: .not.vars_defined ; time to gather and write ", trim(var%name)
@@ -1037,5 +1049,5 @@
     ENDIF
 !$OMP MASTER
-    CALL grid1Dto2D_mpi(buffer_omp,Field2d)
+    IF (grid_type==regular_lonlat) CALL grid1Dto2D_mpi(buffer_omp,Field2d)
 
 ! La boucle sur les fichiers:
@@ -1047,11 +1059,22 @@
              write(lunout,*)'Dans iophy histwrite2D,var%name ', trim(var%name)                       
           ENDIF
-          IF (SIZE(field) == klon) then
+          
+          IF (grid_type==regular_lonlat) THEN
+            IF (SIZE(field) == klon) then
               CALL xios_send_field(var%name, Field2d)
-          ELSE
-             CALL xios_send_field(var%name, field)
-          ENDIF 
+            ELSE
+               CALL xios_send_field(var%name, field)
+            ENDIF 
+          ELSE IF (grid_type==unstructured) THEN
+            IF (SIZE(field) == klon) then
+              CALL xios_send_field(var%name, buffer_omp)
+            ELSE
+               CALL xios_send_field(var%name, field)
+            ENDIF
+
+          ENDIF
           IF (prt_level >= 10) THEN
-             WRITE (lunout,*)'Dans iophy histwrite2D,var%name apres xios_send ', trim(var%name)                       
+             write(lunout,*)'Dans iophy histwrite2D,var%name apres xios_send ',&
+                             trim(var%name)                       
           ENDIF
 #else
@@ -1065,12 +1088,22 @@
                IF (firstx) THEN
                   IF (prt_level >= 10) THEN
-                     WRITE (lunout,*)'Dans iophy histwrite2D,iff,var%name ', iff,trim(var%name)                       
-                     WRITE (lunout,*)"histwrite2d_phy:.NOT.clef_stations(iff)and iff==iff_beg, call xios_send_field"
+                     write(lunout,*)'Dans iophy histwrite2D,iff,var%name ',&
+                                    iff,trim(var%name)                       
+                     write(lunout,*)"histwrite2d_phy:.NOT.clef_stations(iff)and iff==iff_beg, call xios_send_field"
                   ENDIF
-                  IF (SIZE(field) == klon) then
-                     CALL xios_send_field(var%name, Field2d)
-                  ELSE
-                     CALL xios_send_field(var%name, field)
+                  IF (grid_type==regular_lonlat) THEN
+                    IF (SIZE(field) == klon) then
+                       CALL xios_send_field(var%name, Field2d)
+                    ELSE
+                       CALL xios_send_field(var%name, field)
+                    ENDIF
+                  ELSE IF (grid_type==unstructured) THEN
+                    IF (SIZE(field) == klon) then
+                      CALL xios_send_field(var%name, buffer_omp)
+                    ELSE
+                      CALL xios_send_field(var%name, field)
+                    ENDIF
                   ENDIF
+
                   firstx=.false.
                ENDIF
@@ -1085,7 +1118,7 @@
 !#ifdef CPP_XIOS
 !                        IF (iff == iff_beg) THEN
-!                          if (prt_level >= 10) then
+!                          IF (prt_level >= 10) THEN
 !                            write(lunout,*)"histwrite2d_phy: .NOT.clef_stations(iff) and iff==iff_beg, call xios_send_field"
-!                          endif
+!                          ENDIF
 !                          CALL xios_send_field(var%name, Field2d)
 !                        ENDIF
@@ -1109,5 +1142,5 @@
                        ENDIF ! of IF (is_sequential)
 #ifndef CPP_IOIPSL_NO_OUTPUT 
-                       IF (prt_level >= 10) THEn
+                       IF (prt_level >= 10) THEN
                          write(lunout,*)"histwrite2d_phy: clef_stations(iff) and iff==iff_beg, call wxios_write_2D"
                        ENDIF
@@ -1141,5 +1174,5 @@
                                  nfiles, vars_defined, clef_stations, &
                                  nid_files, swaerofree_diag
-  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat, grid_type, regular_lonlat, unstructured
 #ifdef CPP_XIOS
   USE xios, ONLY: xios_send_field
@@ -1191,5 +1224,5 @@
     !Et sinon on.... écrit
 
-    IF (SIZE(field,1)/=klon .AND. SIZE(field,1)/=klev) CALL abort_physic('iophy::histwrite3d_xios','Field first DIMENSION not equal to klon/klev',1)
+    IF (SIZE(field,1)/=klon .AND. SIZE(field,1)/=klev .AND. SIZE(field,1)/=klev+1) CALL abort_physic('iophy::histwrite3d_phy','Field first DIMENSION not equal to klon/klev',1)
 
     nlev=SIZE(field,2)
@@ -1206,5 +1239,5 @@
     ENDIF
 !$OMP MASTER
-    CALL grid1Dto2D_mpi(buffer_omp,field3d)
+    IF (grid_type==regular_lonlat) CALL grid1Dto2D_mpi(buffer_omp,field3d)
 
 ! BOUCLE SUR LES FICHIERS
@@ -1213,12 +1246,22 @@
     IF (ok_all_xml) THEN
 #ifdef CPP_XIOS
-        IF (prt_level >= 10) THEN
-             write(lunout,*)'Dans iophy histwrite3D,var%name ',trim(var%name)                       
+          IF (prt_level >= 10) THEN
+             write(lunout,*)'Dans iophy histwrite3D,var%name ',&
+                             trim(var%name)                       
+          ENDIF
+          IF (grid_type==regular_lonlat) THEN
+            IF (SIZE(field,1) == klon) then
+               CALL xios_send_field(var%name, Field3d(:,:,1:nlevx))
+            ELSE
+               CALL xios_send_field(var%name, field)
+            ENDIF
+          ELSE IF (grid_type==unstructured) THEN
+            IF (SIZE(field,1) == klon) then
+               CALL xios_send_field(var%name, buffer_omp(:,1:nlevx))
+            ELSE
+               CALL xios_send_field(var%name, field)
+            ENDIF
         ENDIF
-        IF (SIZE(field,1) == klon) then
-             CALL xios_send_field(var%name, Field3d(:,:,1:nlevx))
-        ELSE
-             CALL xios_send_field(var%name, field)
-        ENDIF
+
 #else
         CALL abort_physic ('iophy','cannot have ok_all_xml = .T. without CPP_XIOS defined' ,1)
@@ -1230,16 +1273,25 @@
 #ifdef CPP_XIOS
               IF (firstx) THEN
-                IF (prt_level >= 10) THEn
-                  WRITE (lunout,*)'Dans iophy, histwrite3D iff nlev klev firstx', &
+                IF (prt_level >= 10) THEN
+                  write(lunout,*)'Dans iophy, histwrite3D iff nlev klev firstx', &
                                   iff,nlev,klev, firstx                       
-                  WRITE (lunout,*)'histwrite3d_phy: call xios_send_field for ', &
+                  write(lunout,*)'histwrite3d_phy: call xios_send_field for ', &
                                   trim(var%name), ' with iim jjm nlevx = ', &
                                   nbp_lon,jj_nb,nlevx
                 ENDIF
-                IF (SIZE(field,1) == klon) then
-                    CALL xios_send_field(var%name, Field3d(:,:,1:nlevx))
-                ELSE
+                IF (grid_type==regular_lonlat) THEN
+                  IF (SIZE(field,1) == klon) then
+                      CALL xios_send_field(var%name, Field3d(:,:,1:nlevx))
+                  ELSE
+                       CALL xios_send_field(var%name, field)
+                  ENDIF
+                ELSE IF (grid_type==unstructured) THEN
+                  IF (SIZE(field,1) == klon) then
+                     CALL xios_send_field(var%name, buffer_omp(:,1:nlevx))
+                  ELSE
                      CALL xios_send_field(var%name, field)
+                  ENDIF
                 ENDIF
+
                 firstx=.false.
               ENDIF
@@ -1305,5 +1357,5 @@
                                 is_sequential, klon_mpi_begin, klon_mpi_end, &
                                 jj_nb, klon_mpi, is_master
-  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat, grid_type, unstructured
   USE xios, ONLY: xios_send_field
   USE print_control_mod, ONLY: prt_level,lunout
@@ -1325,9 +1377,9 @@
   IF (prt_level >= 10) WRITE(lunout,*)'Begin histrwrite2d_xios ',field_name
 
-  !Et sinon on.... écrit
-  IF (SIZE(field)/=klon .AND. SIZE(field)/=klev) CALL abort_physic('iophy::histwrite2d_xios','Field first DIMENSION not equal to klon/klev',1)
-    
-  IF (SIZE(field) == klev) then
+    !Et sinon on.... écrit
+    IF (SIZE(field)/=klon .AND. SIZE(field)/=klev .AND. SIZE(field)/=klev+1) CALL abort_physic('iophy::histwrite2d_xios','Field first DIMENSION not equal to klon/klev',1)
+    IF (SIZE(field) == klev .OR. SIZE(field) == klev+1) then
 !$OMP MASTER
+
         CALL xios_send_field(field_name,field)
 !$OMP END MASTER   
@@ -1335,4 +1387,11 @@
         CALL Gather_omp(field,buffer_omp)    
 !$OMP MASTER
+
+      IF (grid_type==unstructured) THEN
+  
+        CALL xios_send_field(field_name, buffer_omp)
+
+      ELSE
+
         CALL grid1Dto2D_mpi(buffer_omp,Field2d)
     
@@ -1342,7 +1401,4 @@
     !IF(.NOT.clef_stations(iff)) THEN
         IF (.TRUE.) THEN
-            ALLOCATE(index2d(nbp_lon*jj_nb))
-            ALLOCATE(fieldok(nbp_lon*jj_nb))
-    
     
             CALL xios_send_field(field_name, Field2d)
@@ -1365,9 +1421,9 @@
                 ENDDO
             ENDIF
-    
-        ENDIF
-                  
-        DEALLOCATE(index2d)
-        DEALLOCATE(fieldok)
+            DEALLOCATE(index2d)
+            DEALLOCATE(fieldok)
+    
+        ENDIF                  
+      ENDIF
 !$OMP END MASTER   
   ENDIF
@@ -1385,5 +1441,5 @@
                                 jj_nb, klon_mpi, is_master
   USE xios, ONLY: xios_send_field
-  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+  USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat, grid_type, unstructured
   USE print_control_mod, ONLY: prt_level,lunout
 
@@ -1403,8 +1459,11 @@
   IF (prt_level >= 10) write(lunout,*)'Begin histrwrite3d_xios ',field_name
 
-  !Et on.... écrit
-  IF (SIZE(field,1)/=klon .AND. SIZE(field,1)/=klev) CALL abort_physic('iophy::histwrite3d_xios','Field first DIMENSION not equal to klon/klev',1)
-    
-  IF (SIZE(field,1) == klev) then
+    !Et on.... écrit
+    IF (SIZE(field,1)/=klon .AND. SIZE(field,1)/=klev .AND. SIZE(field,1)/=klev+1) then
+      write(lunout,*)' histrwrite3d_xios ', field_name, SIZE(field)
+      CALL abort_physic('iophy::histwrite3d_xios','Field first DIMENSION not equal to klon/klev',1)
+    ENDIF
+    
+    IF (SIZE(field,1) == klev .OR. SIZE(field,1) == klev+1) then
 !$OMP MASTER
         CALL xios_send_field(field_name,field)
@@ -1416,4 +1475,10 @@
         CALL Gather_omp(field,buffer_omp)
 !$OMP MASTER
+
+    IF (grid_type==unstructured) THEN
+
+      CALL xios_send_field(field_name, buffer_omp(:,1:nlev))
+
+    ELSE
         CALL grid1Dto2D_mpi(buffer_omp,field3d)
 
@@ -1423,7 +1488,6 @@
     !IF (.NOT.clef_stations(iff)) THEN
         IF(.TRUE.)THEN
-            ALLOCATE(index3d(nbp_lon*jj_nb*nlev))
-            ALLOCATE(fieldok(nbp_lon*jj_nb,nlev))
-            CALL xios_send_field(field_name, Field3d(:,:,1:nlev))
+
+           CALL xios_send_field(field_name, Field3d(:,:,1:nlev))
                             
         ELSE 
@@ -1448,7 +1512,8 @@
                 ENDDO
             ENDIF
+            DEALLOCATE(index3d)
+            DEALLOCATE(fieldok)
         ENDIF 
-        DEALLOCATE(index3d)
-        DEALLOCATE(fieldok)
+      ENDIF
 !$OMP END MASTER   
   ENDIF
